%% 2-Country, 2-sector NK model with Impatient/Patient Households and
%% Mortage Risk, Entrepreneurs with BGG friction and cross border 
%% Lending
%% Jonathan Swarbrick 2014


@#include "variable_declaration.mod"

%% Parameterisations
@#include "parameterisations.mod"
    Pi_bar = 1.005;
@#include "steady_state_parameters.mod"

external_function(name=logncdf, nargs=3);

model;

@#include "log_var_definitions.mod"

# Fa = logncdf(Omegaa,-0.5*(Riska)^2,Riska);
# lag_Fa = logncdf(lag_Omegaa,-0.5*(lag_Riska)^2,lag_Riska);
# Fa_s = logncdf(Omegaa_s,-0.5*(Riska_s)^2,Riska_s);
# lag_Fa_s = logncdf(lag_Omegaa_s,-0.5*(lag_Riska_s)^2,lag_Riska_s);
# Fp = logncdf(Omegap,-0.5*(lag_Riskp)^2,lag_Riskp);
# Fp_s = logncdf(Omegap_s,-0.5*(lag_Riskp_s)^2,lag_Riskp_s);
# Ga = 1- normcdf((0.5*(Riska)^2 -log(Omegaa))/Riska,0,1);
# lag_Ga = 1- normcdf((0.5*(lag_Riska)^2 -log(lag_Omegaa))/lag_Riska,0,1);
# Gp = 1- normcdf((0.5*(lag_Riskp)^2 -log(Omegap))/lag_Riskp,0,1);
# lead_Gp = 1- normcdf((0.5*(Riskp)^2 -log(Omegaa))/Riskp,0,1);
# Ga_s = 1- normcdf((0.5*(Riska_s)^2 -log(Omegaa_s))/Riska_s,0,1);
# lag_Ga_s = 1- normcdf((0.5*(lag_Riska_s)^2 -log(lag_Omegaa_s))/lag_Riska_s,0,1);
# Gp_s = 1- normcdf((0.5*(lag_Riskp_s)^2 -log(Omegap_s))/lag_Riskp_s,0,1);
# lead_Gp_s = 1- normcdf((0.5*(Riskp_s)^2 -log(Omegaa_s))/Riskp_s,0,1);

# FFa = logncdf(OmegaFa,-0.5*(RiskFa)^2,RiskFa);
# lag_FFa = logncdf(lag_OmegaFa,-0.5*(lag_RiskFa)^2,lag_RiskFa);
# FFa_s = logncdf(OmegaFa_s,-0.5*(RiskFa_s)^2,RiskFa_s);
# lag_FFa_s = logncdf(lag_OmegaFa_s,-0.5*(lag_RiskFa_s)^2,lag_RiskFa_s);
# FFp = logncdf(OmegaFp,-0.5*(lag_RiskFp)^2,lag_RiskFp);
# FFp_s = logncdf(OmegaFp_s,-0.5*(lag_RiskFp_s)^2,lag_RiskFp_s);
# GFa = 1- normcdf((0.5*(RiskFa)^2 -log(OmegaFa))/RiskFa,0,1);
# lag_GFa = 1- normcdf((0.5*(lag_RiskFa)^2 -log(lag_OmegaFa))/lag_RiskFa,0,1);
# GFp = 1- normcdf((0.5*(lag_RiskFp)^2 -log(OmegaFp))/lag_RiskFp,0,1);
# lead_GFp = 1- normcdf((0.5*(RiskFp)^2 -log(OmegaFa))/RiskFp,0,1);
# GFa_s = 1- normcdf((0.5*(RiskFa_s)^2 -log(OmegaFa_s))/RiskFa_s,0,1);
# lag_GFa_s = 1- normcdf((0.5*(lag_RiskFa_s)^2 -log(lag_OmegaFa_s))/lag_RiskFa_s,0,1);
# GFp_s = 1- normcdf((0.5*(lag_RiskFp_s)^2 -log(OmegaFp_s))/lag_RiskFp_s,0,1);
# lead_GFp_s = 1- normcdf((0.5*(RiskFp_s)^2 -log(OmegaFa_s))/RiskFp_s,0,1);

// Hours
# H_borr = Hc_borr+Hd_borr;
# H_s_borr = Hc_borr_s+Hd_borr_s;
# lead_H_borr = lead_Hc_borr+lead_Hd_borr;
# lead_H_s_borr = lead_Hc_borr_s+lead_Hd_borr_s;
# H = Hc+Hd;
# H_s = Hc_s+Hd_s;
# H_total=lambda*H+(1-lambda)*H_borr;
# H_total_s=lambda*H_s+(1-lambda)*H_s_borr;  
# Hc_tot = lambda*Hc + (1-lambda)*Hc_borr;
# Hc_tot_s = lambda*Hc_s + (1-lambda)*Hc_borr_s;
# lag_Hc_tot = lambda*lag_Hc + (1-lambda)*lag_Hc_borr;
# lag_Hc_tot_s = lambda*lag_Hc_s + (1-lambda)*lag_Hc_borr_s;
# lead_Hc_tot = lambda*lead_Hc + (1-lambda)*lead_Hc_borr;
# lead_Hc_tot_s = lambda*lead_Hc_s + (1-lambda)*lead_Hc_borr_s;
# Hd_tot = lambda*Hd + (1-lambda)*Hd_borr;
# Hd_tot_s = lambda*Hd_s + (1-lambda)*Hd_borr_s;
# lag_Hd_tot = lambda*lag_Hd + (1-lambda)*lag_Hd_borr;
# lag_Hd_tot_s = lambda*lag_Hd_s + (1-lambda)*lag_Hd_borr_s;

//Capital 
# X = I/I(-1);
# X_s = I_s/I_s(-1);
# lead_X = I(+1)/I;
# lead_X_s = I_s(+1)/I_s;
# Kc = lag_K - Kd;
# Kc_s = lag_K_s - Kd_s;
# lag_Kc = lag_lag_K - lag_Kd;
# lag_Kc_s = lag_lag_K_s - lag_Kd_s;
# lead_Kc = K - lead_Kd;
# lead_Kc_s = K_s - lead_Kd_s;

// production
# Ycw = A*Zc*Hc_tot^(1-alppha)*(Kc)^alppha;
# Ycw_s = A*Zc_s*Hc_tot_s^(1-alppha)*(Kc_s)^alppha;
# lead_Ycw = A(+1)*lead_Zc*lead_Hc_tot^(1-alppha)*(lead_Kc)^alppha;
# lead_Ycw_s = A(+1)*lead_Zc_s*lead_Hc_tot_s^(1-alppha)*(lead_Kc_s)^alppha;
# lag_Ycw = A(-1)*lag_Zc*lag_Hc_tot^(1-alppha)*(lag_Kc)^alppha;
# lag_Ycw_s = A(-1)*lag_Zc_s*lag_Hc_tot_s^(1-alppha)*(lag_Kc_s)^alppha;
# Ydw = A*Zd*Hd_tot^(1-alppha)*(Kd)^alppha;
# Ydw_s = A*Zd_s*Hd_tot_s^(1-alppha)*(Kd_s)^alppha;
# lag_Ydw = A(-1)*lag_Zd*lag_Hd_tot^(1-alppha)*(lag_Kd)^alppha;
# lag_Ydw_s = A(-1)*lag_Zd_s*lag_Hd_tot_s^(1-alppha)*(lag_Kd_s)^alppha;

//final output 
# Yc = Ycw/dispc;
# Yc_s = Ycw_s/dispc_s;
# Yd = Ydw/dispd;
# Yd_s = Ydw_s/dispd_s;
# lag_Yc = lag_Ycw/lag_dispc;
# lag_Yc_s = lag_Ycw_s/lag_dispc_s;
# lag_Yd = lag_Ydw/lag_dispd;
# lag_Yd_s = lag_Ydw_s/lag_dispd_s;

//total output
# Y = Yc +Yd*PD_by_PC;
# Y_s = Yc_s +Yd_s*PD_by_PC_s;
# lag_Y = lag_Yc +lag_Yd*lag_PD_by_PC;
# lag_Y_s = lag_Yc_s + lag_Yd_s*lag_PD_by_PC_s;
# Y_emu = n*Y +(1-n)*Y_s;
# lag_Y_emu = n*lag_Y +(1-n)*lag_Y_s;

// Inflation and Interbank Interest Spread
# Pi_EMU = Pic^n *Pic_s^(1-n);
# policy_IB_spread = 0;
# lag_policy_IB_spread = 0;
# R_ib = R + policy_IB_spread;
# lag_R_ib = lag_R + lag_policy_IB_spread;
# R_ib_s = R_ib + exp(premium)*exp(kappa_b*b)-1;
# lag_R_ib_s = lag_R_ib + exp(premium(-1))*exp(kappa_b*b(-1))-1;

// consumption
# C_tot = lambda*C + (1-lambda)*C_borr;
# C_s_tot = lambda*C_s + (1-lambda)*C_s_borr;
# C_H = tauC*(1/(tauC +(1-tauC)*Terms^(1-iota_C)))^(-iota_C/(1-iota_C)) *C_tot;
# C_F = (1-tauC)*(1/(tauC*Terms^(-(1-iota_C)) +(1-tauC)))^(-iota_C/(1-iota_C)) *C_tot;
# C_F_s = tauC_s*(1/(tauC_s +(1-tauC_s)*Terms^(-(1-iota_C))))^(-iota_C/(1-iota_C)) *C_s_tot;
# C_H_s = (1-tauC_s)*(1/(tauC_s*Terms^(1-iota_C) +(1-tauC_s)))^(-iota_C/(1-iota_C)) *C_s_tot;

// marginal utility
# UC = (gama*Prefc)/(C-epsilon*lag_C);
# UC_s = gamma_s*Prefc_s/(C_s-epsilon*lag_C_s);
# lead_UC = gama*lead_Prefc/(lead_C-epsilon*C);
# lead_UC_s = gamma_s*lead_Prefc_s/(lead_C_s-epsilon*C_s);
# lag_UC = (gama*lag_Prefc)/(lag_C-epsilon*lag_lag_C);
# lag_UC_s = gamma_s*lag_Prefc_s/(lag_C_s-epsilon*lag_lag_C_s);
# LAMBDA = lead_LAMBDA(-1);
# LAMBDA_s = lead_LAMBDA(-1);

// wages (from borrowers labour supply
# W = H_borr^(phi)*(C_borr -epsilon_borr*lag_C_borr)/(gama*Prefc);
# lead_W = lead_H_borr^(phi)*(lead_C_borr -epsilon_borr*C_borr)/(gama*lead_Prefc);
# W_s = H_s_borr^(phi)*(C_s_borr -epsilon_borr*lag_C_s_borr)/(gamma_s*Prefc_s);
# lead_W_s = lead_H_s_borr^(phi)*(lead_C_s_borr -epsilon_borr*C_s_borr)/(gamma_s*lead_Prefc_s);

// marginal costs
# MCd = (1-alppha)^(-1)*W/(Ydw/Hd_tot)/PD_by_PC;
# MCd_s = (1-alppha)^(-1)*W_s/(Ydw_s/Hd_tot_s)/PD_by_PC_s;
# MCc = (1-alppha)^(-1)*W/(Ycw/Hc_tot)*((tauC +(1-tauC)*Terms^(1-iota_C)))^(1/(1-iota_C));
# MCc_s = (1-alppha)^(-1)*W_s/(Ycw_s/Hc_tot_s)*((tauC_s +(1-tauC_s)*Terms^(-(1-iota_C))))^(1/(1-iota_C));
# lead_MCc = (1-alppha)^(-1)*lead_W/(lead_Ycw/lead_Hc_tot)*((tauC +(1-tauC)*lead_Terms^(1-iota_C)))^(1/(1-iota_C));
# lead_MCc_s = (1-alppha)^(-1)*lead_W_s/(lead_Ycw_s/lead_Hc_tot_s)*((tauC_s +(1-tauC_s)*lead_Terms^(-(1-iota_C))))^(1/(1-iota_C));

// average interest rates of those who default
# RD = Gp*PD_by_PC*D_borr*Pic/lag_L_borr;
# RD_s = Gp_s*PD_by_PC_s*D_borr_s*Pic_s/lag_L_borr_s;
# lead_RD = lead_Gp*lead_PD_by_PC*lead_D_borr*lead_Pic/L_borr;
# lead_RD_s = lead_Gp_s*lead_PD_by_PC_s*lead_D_borr_s*lead_Pic_s/L_borr_s;

//Entrepreneur Loans
# RLF = (tauL*RLF_H^(1-iota_L) + (1-tauL)*RLF_H_s^(1-iota_L))^(1/(1-iota_L));
# RLF_s = (tauL*RLF_F_s^(1-iota_L) + (1-tauL)*RLF_F^(1-iota_L))^(1/(1-iota_L));
# lag_RLF = (tauL*lag_RLF_H^(1-iota_L) + (1-tauL)*lag_RLF_H_s^(1-iota_L))^(1/(1-iota_L));
# lag_RLF_s = (tauL*lag_RLF_F_s^(1-iota_L) + (1-tauL)*lag_RLF_F^(1-iota_L))^(1/(1-iota_L));
# LF_H = tauL*(RLF_H/RLF)^(-iota_L)*LF;
# lag_LF_H = tauL*(lag_RLF_H/lag_RLF)^(-iota_L)*lag_LF;
# LF_F = (1-tauL)*(RLF_H_s/RLF)^(-iota_L)*LF;
# lag_LF_F = (1-tauL)*(lag_RLF_H_s/lag_RLF)^(-iota_L)*lag_LF;
# LF_F_s = tauL_s*(RLF_F_s/RLF_s)^(-iota_L)*LF_s;
# lag_LF_F_s = tauL_s*(lag_RLF_F_s/lag_RLF_s)^(-iota_L)*lag_LF_s;
# LF_H_s = (1-tauL_s)*(RLF_F/RLF_s)^(-iota_L)*LF_s;
# lag_LF_H_s = (1-tauL_s)*(lag_RLF_F/lag_RLF_s)^(-iota_L)*lag_LF_s;
# LbF = LF_H + LF_H_s*(1-n)/n;
# LbF_s = LF_F*n/(1-n) + LF_F_s;
# lag_LbF = lag_LF_H + lag_LF_H_s*(1-n)/n;
# lag_LbF_s = lag_LF_F*n/(1-n) + lag_LF_F_s;

// Bank Lending Rates
# Bb = (1-lambda)*L_borr + LbF;
# Bb_s = (1-lambda)*L_borr_s + LbF_s;
# lag_Bb = (1-lambda)*lag_L_borr + lag_LbF;
# lag_Bb_s = (1-lambda)*lag_L_borr_s + lag_LbF_s;
# Rb = R_ib - kappaK*(lag_Kb/lag_Bb - etab)*(lag_Kb/lag_Bb)^2;
# Rb_s = R_ib_s - kappaK*(lag_Kb_s/lag_Bb_s - etab_s)*(lag_Kb_s/lag_Bb_s)^2;

# LF_H_s_bar = (1-tauL_s)*(STEADY_STATE(exp(lf_s)));
# LF_H_bar = tauL*(STEADY_STATE(exp(lf)));
# LbF_bar = LF_H_bar + LF_H_s_bar*(1-n)/n;
# Bb_bar = (1-lambda)*exp(STEADY_STATE(l_borr)) + LbF_bar;
# Bb_s_bar_ = Bb_bar;
# Y_bar_ = K_by_H^alppha*(lambda*(exp(STEADY_STATE(hc))+exp(STEADY_STATE(hd)))
    + (1-lambda)*(exp(STEADY_STATE(hc_borr))+exp(STEADY_STATE(hd_borr))));
# Y_s_bar_ = Y_bar_;

//Capital rental rate, gross return on capital, business loan rates
# rK = alppha*MCc*Ycw/Kc;
# rK_s = alppha*MCc_s*Ycw_s/Kc_s;
# lead_rK = alppha*lead_MCc*lead_Ycw/lead_Kc;
# lead_rK_s = alppha*lead_MCc_s*lead_Ycw_s/lead_Kc_s;
# RK = (rK+(1-deltaK)*tobinQ)/lag_tobinQ;
# RK_s = (rK_s+(1-deltaK)*tobinQ_s)/lag_tobinQ_s;
# lead_RK = (lead_rK+(1-deltaK)*lead_tobinQ)/tobinQ;
# lead_RK_s = (lead_rK_s+(1-deltaK)*lead_tobinQ_s)/tobinQ_s;

// Entrepreneur Net Worth and consumption on exit
# N = (gammaB)*((1-GFp)*RK*lag_tobinQ*lag_K - (1-FFp)*lag_RLF*lag_LF);
# N_s = (gammaB)*((1-GFp_s)*RK_s*lag_tobinQ_s*lag_K_s - (1-FFp_s)*lag_RLF_s*lag_LF_s);
# C_exit = Theta*(1-gammaB)*N/(gammaB);
# C_s_exit = Theta*(1-gammaB)*N_s/(gammaB);
# tax_exiting_entrepreneur = (1-Theta)*(1-gammaB)*N/(gammaB);
# tax_exiting_entrepreneur_s = (1-Theta)*(1-gammaB)*N_s/(gammaB);
# T_borr = (Gov - tax_exiting_entrepreneurs_on*tax_exiting_entrepreneur)/(1-lambda); 
# T_borr_s = (Gov_s - tax_exiting_entrepreneurs_on*tax_exiting_entrepreneur_s)/(1-lambda); 

// Entrepreneur FOC
# FFa_omegaF = 1/(OmegaFa*RiskFa*sqrt(2*pi))*exp(-(log(OmegaFa)+.5*(RiskFa)^2)^2/(2*(RiskFa)^2));
# FFa_omegaF_s = 1/(OmegaFa_s*RiskFa_s*sqrt(2*pi))*exp(-(log(OmegaFa_s)+.5*(RiskFa_s)^2)^2/(2*(RiskFa_s)^2)); 
//# FFa_omegaF = 1/(2*lead_aF);
//# FFa_omegaF_s = 1/(2*lead_aF_s); 

// Entrepreneur demand for loans
# varrhoF1 = (varrhoF2*((1-muF_dom)+(1-FFa)/FFa_omegaF*1/OmegaFa*LF/LF_F-RLF_H_s/RLF)-LF*((1-FFa)/(FFa_omegaF*OmegaFa)))/(RLF_H/RLF-(1-muF_dom));
# varrhoF1_s = (varrhoF2_s*((1-muF_dom)+(1-FFa_s)/FFa_omegaF_s*1/OmegaFa_s*LF_s/LF_H_s-RLF_F/RLF_s)-LF_s*((1-FFa_s)/(FFa_omegaF_s*OmegaFa_s)))/(RLF_F_s/RLF_s-(1-muF_dom));

// Bank Capital
# lag_b_s = -n*b(-1)/(1-n);
# lag_Sb = lag_Bb - lag_Kb - b(-1);
# lag_Sb_s = lag_Bb_s - lag_Kb_s - lag_b_s;
# bank_cost = kappaK/2*(lag_Kb/lag_Bb - etab(-1))^2*lag_Kb;
# bank_cost_s = kappaK/2*(lag_Kb_s/lag_Bb_s - etab_s(-1))^2*lag_Kb_s;
# RbFp_H = (1-muF_dom)*GFp*lag_RLF/OmegaFp + (1-FFp)*lag_RLF_H;
# RbFp_F = (1-muF_dom)*GFp_s*lag_RLF_s/OmegaFp_s + (1-FFp_s)*lag_RLF_F;
# RbFp_F_s = (1-muF_dom)*GFp_s*lag_RLF_s/OmegaFp_s + (1-FFp_s)*lag_RLF_F_s;
# RbFp_H_s = (1-muF_dom)*GFp*lag_RLF/OmegaFp + (1-FFp)*lag_RLF_H_s;
# RbLp = lag_RL*((1-muB)*Gp/Omegap + (1-Fp));
# RbLp_s = lag_RL_s*((1-muB)*Gp_s/Omegap_s + (1-Fp_s));
# J = (1-lambda)*lag_L_borr*(RbLp) + lag_LF_H*(RbFp_H) + ((1-n)/n)*lag_LF_H_s*(RbFp_F) + R_ib*b(-1) - R_ib*lag_Sb - bank_cost;
# J_s = (1-lambda)*lag_L_borr_s*(RbLp_s) + lag_LF_F_s*(RbFp_F_s) + ((1-n)/n)*lag_LF_F*(RbFp_H_s) + R_ib_s*lag_b_s - R_ib_s*lag_Sb_s - bank_cost_s;
# Ib = varphib*J;
# Ib_s = varphib*J_s;


    //Eq #9-->
    betta = betta_bar*TPS;
    beta_borr = beta_borr_bar*TPS;

    // Lead Variables
    lead_Varrho_borr_s = exp(varrho_s_borr(1));
    lead_Varrho_borr = exp(varrho_borr(1));
    lead_Varrho = exp(varrho(1));
    lead_Varrho_s = exp(varrho_s(1));

    lead_LAMBDA = betta*lead_UC/UC;
    lead_LAMBDA_s = betta*lead_UC_s/UC_s;

    // Durable sector capital demand, investment decision, capital accumulation
    rK = alppha*MCd*Ydw/Kd;
    rK_s = alppha*MCd_s*Ydw_s/Kd_s;
    tobinQ*(1-phiX*(X-1)^2 - 2*X*phiX*(X-1)) + 2*phiX*(lead_X-1)*lead_X^2*lead_tobinQ*lead_LAMBDA = 1;
    tobinQ_s*(1-phiX*(X_s-1)^2 - 2*X_s*phiX*(X_s-1)) + 2*phiX*(lead_X_s-1)*lead_X_s^2*lead_tobinQ_s*lead_LAMBDA_s = 1;
    K = I*(1-phiX*(X-1)^2) + (1-deltaK)*lag_K;
    K_s = I_s*(1-phiX*(X_s-1)^2) + (1-deltaK)*lag_K_s;

    // Entrepreneur demand for loans 23-->
    varrhoF2 = (varrhoF1*((1-muF_dom)+(1-FFa)/FFa_omegaF*1/OmegaFa*LF/LF_H-RLF_H/RLF)-LF*((1-FFa)/(FFa_omegaF*OmegaFa)))/(RLF_H_s/RLF-(1-muF_dom));
    varrhoF2_s = (varrhoF1_s*((1-muF_dom)+(1-FFa_s)/FFa_omegaF_s*1/OmegaFa_s*LF_s/LF_F_s-RLF_F_s/RLF_s)-LF_s*((1-FFa_s)/(FFa_omegaF_s*OmegaFa_s)))/(RLF_F/RLF_s-(1-muF_dom));
    lead_RK*((LF+N)*FFa_omegaF*OmegaFa^2/LF-(1-GFa)+(varrhoF1+varrhoF2)*((1-muF_dom)*GFa*N/(LF^2)-(1-muF_dom)*(LF+N)/LF*FFa_omegaF*OmegaFa^2/LF)) = RLF*(FFa_omegaF*OmegaFa-(1-FFa)-(varrhoF1*RLF_H/RLF+varrhoF2*RLF_H_s/RLF)*FFa_omegaF*OmegaFa/LF);
    lead_RK_s*((LF_s+N_s)*FFa_omegaF_s*OmegaFa_s^2/LF_s-(1-GFa_s)+(varrhoF1_s+varrhoF2_s)*((1-muF_dom)*GFa_s*N_s/(LF_s^2)-(1-muF_dom)*(LF_s+N_s)/LF_s*FFa_omegaF_s*OmegaFa_s^2/LF_s)) = RLF_s*(FFa_omegaF_s*OmegaFa_s-(1-FFa_s)-(varrhoF1_s*RLF_F_s/RLF_s+varrhoF2_s*RLF_F/RLF_s)*FFa_omegaF_s*OmegaFa_s/LF_s);
    LF = tobinQ*K - N;
    LF_s = tobinQ_s*K_s - N_s;

    // Bank Participation and Bank Capital
    lead_LAMBDA*( R_ib-kappaK*(Kb/Bb-etab)*(Kb/Bb)^2 ) = lead_LAMBDA*( (1-muF_dom)*GFa*RLF/OmegaFa + (1-FFa)*RLF_H );
    lead_LAMBDA*( R_ib-kappaK*(Kb/Bb-etab)*(Kb/Bb)^2 ) = lead_LAMBDA*( (1-muF_dom)*GFa_s*RLF_s/OmegaFa_s + (1-FFa_s)*RLF_F );
    lead_LAMBDA_s*( R_ib_s-kappaK*(Kb_s/Bb_s-etab_s)*(Kb_s/Bb_s)^2 ) = lead_LAMBDA_s*( (1-muF_dom)*GFa*RLF/OmegaFa + (1-FFa)*RLF_H_s );
    lead_LAMBDA_s*( R_ib_s-kappaK*(Kb_s/Bb_s-etab_s)*(Kb_s/Bb_s)^2 ) = lead_LAMBDA_s*( (1-muF_dom)*GFa_s*RLF_s/OmegaFa_s + (1-FFa_s)*RLF_F_s );
    lead_LAMBDA*( R_ib-kappaK*(Kb/Bb-etab)*(Kb/Bb)^2 ) = lead_LAMBDA*RL*((1-muB)*Ga/Omegaa + (1-Fa));
    lead_LAMBDA_s*( R_ib_s-kappaK*(Kb_s/Bb_s-etab_s)*(Kb_s/Bb_s)^2 ) = lead_LAMBDA_s*RL_s*((1-muB)*Ga_s/Omegaa_s + (1-Fa_s));
    Kb = (1-deltab)*lag_Kb + Ib;
    Kb_s = (1-deltab)*lag_Kb_s + Ib_s;
    etab = etab_bar + kappaM1*(Bb/Y - Bb_bar/Y_bar_);
    etab_s = etab_s_bar + kappaM1*(Bb_s/Y_s - Bb_s_bar_/Y_s_bar_);

    // Ex-ante and ex-post omega's (entrepreneur loans) 40-->
    OmegaFa = RLF*LF/(lead_RK*tobinQ*K);
    OmegaFp = lag_RLF*lag_LF/(RK*lag_tobinQ*lag_K);
    OmegaFa_s = RLF_s*LF_s/(lead_RK_s*tobinQ_s*K_s);
    OmegaFp_s = lag_RLF_s*lag_LF_s/(RK_s*lag_tobinQ_s*lag_K_s);

    // investment decision borrowers
    gama*Prefc/(C_borr-epsilon_borr*lag_C_borr) * PD_by_PC = beta_borr*lead_Varrho_borr*(1 -psi/2*(Inv_borr/lag_Inv_borr-1)^2 -psi*(Inv_borr/lag_Inv_borr-1)*Inv_borr/lag_Inv_borr) + beta_borr^2*lead_Varrho_borr(+1)*psi*(lead_Inv_borr/Inv_borr-1)*(lead_Inv_borr/Inv_borr)^2;
    gamma_s*Prefc_s/(C_s_borr-epsilon_borr*lag_C_s_borr) * PD_by_PC_s = beta_borr*lead_Varrho_borr_s*(1 -psi/2*(Inv_borr_s/lag_Inv_borr_s-1)^2 -psi*(Inv_borr_s/lag_Inv_borr_s-1)*Inv_borr_s/lag_Inv_borr_s) + beta_borr^2*lead_Varrho_borr_s(+1)*psi*(lead_Inv_borr_s/Inv_borr_s-1)*(lead_Inv_borr_s/Inv_borr_s)^2;

    // demand durable consumption borrowers
    (1-gama)*Prefd/D_borr = Varrho_borr -beta_borr*(1-deltta)*lead_Varrho_borr;
    (1-gamma_s)*Prefd_s/D_borr_s = Varrho_borr_s -beta_borr*(1-deltta)*lead_Varrho_borr_s;

    // definition relative prices
    PD_by_PC/lag_PD_by_PC = Pid/Pic;
    PD_by_PC_s/lag_PD_by_PC_s = Pid_s/Pic_s;

    // Euler equation borrowers 50-->
    1 = beta_borr*((1-Fa)*RL+lead_RD) * lead_Pic^(-1) * lead_Prefc/Prefc * (C_borr -epsilon_borr*lag_C_borr)/(lead_C_borr -epsilon_borr*C_borr);
    1 = beta_borr*((1-Fa_s)*RL_s+lead_RD_s) * lead_Pic_s^(-1) * lead_Prefc_s/Prefc_s * (C_s_borr -epsilon_borr*lag_C_s_borr)/(lead_C_s_borr -epsilon_borr*C_s_borr);

    // Ex-ante and ex-post omega's
    Omegaa = RL*L_borr/(lead_PD_by_PC*lead_D_borr*lead_Pic);
    Omegaa_s = RL_s*L_borr_s/(lead_PD_by_PC_s*lead_D_borr_s*lead_Pic_s);
    Omegap = lag_RL*lag_L_borr/(PD_by_PC*D_borr*Pic);
    Omegap_s = lag_RL_s*lag_L_borr_s/(PD_by_PC_s*D_borr_s*Pic_s);

    // budget constraint borrowers
    C_borr +PD_by_PC*Inv_borr +(RD +(1-Fp)*lag_RL)*lag_L_borr/Pic = L_borr + W*Hc_borr + W*Hd_borr + T_borr;
    C_s_borr +PD_by_PC_s*Inv_borr_s +(RD_s +(1-Fp_s)*lag_RL_s)*lag_L_borr_s/Pic_s = L_borr_s + W_s*Hc_borr_s + W_s*Hd_borr_s + T_borr_s;

    // Investment decision savers
    gama*Prefc/(C-epsilon*lag_C) * PD_by_PC = betta*lead_Varrho*(1 -psi/2*(Inv/lag_Inv-1)^2 -psi*(Inv/lag_Inv-1)*Inv/lag_Inv) + betta^2*lead_Varrho(+1)*psi*(lead_Inv/Inv-1)*(lead_Inv/Inv)^2;
    gamma_s*Prefc_s/(C_s-epsilon*lag_C_s) * PD_by_PC_s = betta*lead_Varrho_s*(1 -psi/2*(Inv_s/lag_Inv_s-1)^2 -psi*(Inv_s/lag_Inv_s-1)*Inv_s/lag_Inv_s) + betta^2*lead_Varrho_s(+1)*psi*(lead_Inv_s/Inv_s-1)*(lead_Inv_s/Inv_s)^2;

    // demand durable consumption savers 60-->
    (1-gama)*Prefd/D = Varrho -betta*(1-deltta)*lead_Varrho;
    (1-gamma_s)*Prefd_s/D_s = Varrho_s -betta*(1-deltta)*lead_Varrho_s;

    // Euler equation savers
    1 = betta*R_ib * lead_Pic^(-1) * lead_Prefc/Prefc * (C -epsilon*lag_C)/(lead_C -epsilon*C);
    1 = betta* R_ib_s * lead_Pic_s^(-1) * lead_Prefc_s/Prefc_s * (C_s -epsilon*lag_C_s)/(lead_C_s -epsilon*C_s);

    // labor supply savers
    H^(phi) = gama*Prefc/(C -epsilon*lag_C) * W;
    H_s^(phi) = gamma_s*Prefc_s/(C_s -epsilon*lag_C_s) * W_s;

    //  66-->
    sigmma/(sigmma-1) * Xc1 = Xc2 * exp(phtilde);
    Xc1 = UC*MCc*Ycw +betta*theta_c*(lead_Pi_H)^(1+sigmma) *lead_Xc1;
    Xc2 = UC*Ycw +betta*theta_c*(lead_Pi_H)^(sigmma)*lead_Xc2;
    sigmma/(sigmma-1) * Xc1_s = Xc2_s * exp(pftilde);
    Xc1_s = UC_s*MCc_s*Ycw_s +betta*theta_c_s*(lead_Pi_F)^(1+sigmma) *lead_Xc1_s;
    Xc2_s = UC_s*Ycw_s +betta*theta_c_s*(lead_Pi_F)^(sigmma)*lead_Xc2_s;
    1 = theta_c*(Pi_H)^(sigmma-1) +(1-theta_c)*exp(phtilde)^(1-sigmma);
    1 = theta_c_s*(Pi_F)^(sigmma-1) +(1-theta_c_s)*exp(pftilde)^(1-sigmma);
    dispc = theta_c*(Pi_H)^(sigmma)*lag_dispc +(1-theta_c)*exp(phtilde)^(-sigmma);
    dispc_s = theta_c_s*(Pi_F)^(sigmma) *lag_dispc_s +(1-theta_c_s)*exp(pftilde)^(-sigmma);

    // price dynamics, price dispersion, price setting in the non-durable sector 76-->
    sigmma/(sigmma-1) * Xd1 = Xd2 *exp(pdtilde);
    Xd1 = UC*MCd*Ydw +betta*theta_d*(lead_Pid)^(1+sigmma) *lead_Xd1;
    Xd2 = UC*Ydw +betta*theta_d*(lead_Pid)^(sigmma)*lead_Xd2;
    sigmma/(sigmma-1) * Xd1_s = Xd2_s *exp(pdtilde_s);
    Xd1_s = UC_s*MCd_s*Ydw_s +betta*theta_d_s*(lead_Pid_s)^(1+sigmma) *lead_Xd1_s;
    Xd2_s = UC_s*Ydw_s +betta*theta_d_s*(lead_Pid_s)^(sigmma)*lead_Xd2_s;
    1 = theta_d*(Pid)^(sigmma-1) +(1-theta_d)*exp(pdtilde)^(1-sigmma);
    1 = theta_d_s*(Pid_s)^(sigmma-1) +(1-theta_d_s)*exp(pdtilde_s)^(1-sigmma);
    dispd = theta_d*(Pid)^(sigmma) *lag_dispd +(1-theta_d)*exp(pdtilde)^(-sigmma);
    dispd_s = theta_d_s*(Pid_s)^(sigmma) *lag_dispd_s +(1-theta_d_s)*exp(pdtilde_s)^(-sigmma);


    //CPI inflation 86-->
    Pic^(1-iota_C) = Pi_H^(1-iota_C)*(tauC +(1-tauC)*Terms^(1-iota_C))/(tauC +(1-tauC)*lag_Terms^(1-iota_C));
    Pic_s^(1-iota_C) = Pi_F^(1-iota_C)*(tauC_s +(1-tauC_s)*Terms^(-(1-iota_C)))/(tauC_s +(1-tauC_s)*lag_Terms^(-(1-iota_C)));

    //market clearing
    n*Yc = n*C_H +(1-n)*C_H_s + n*(C_exit + I + Ib) + n*Gov;
    (1-n)*Yc_s = n*C_F +(1-n)*C_F_s + (1-n)*(C_s_exit + I_s + Ib_s) + (1-n)*Gov_s;
    Yd = lambda*Inv +(1-lambda)*Inv_borr;
    Yd_s = lambda*Inv_s +(1-lambda)*Inv_borr_s;

    //law of motion housing stock 92-->
    D_borr = (1-deltta)*lag_D_borr +lag_Inv_borr -(psi/2)*(lag_Inv_borr/lag_lag_Inv_borr -1)^2 *lag_Inv_borr;
    D_borr_s = (1-deltta)*lag_D_borr_s +lag_Inv_borr_s -(psi/2)*(lag_Inv_borr_s/lag_lag_Inv_borr_s -1)^2 *lag_Inv_borr_s;
    D = (1-deltta)*lag_D +lag_Inv -(psi/2)*(lag_Inv/lag_lag_Inv -1)^2 *lag_Inv;
    D_s = (1-deltta)*lag_D_s +lag_Inv_s -(psi/2)*(lag_Inv_s/lag_lag_Inv_s -1)^2 *lag_Inv_s;

    Hc/Hd=Hc_borr/Hd_borr;
    Hc_s/Hd_s=Hc_borr_s/Hd_borr_s;

    //terms of trade, euro-area CPI inflation, Taylor rule, UIP condition, evolution of net foreign assets 
    Terms/lag_Terms = Pi_F/Pi_H;
    R = (RR_bar)^(1-gamma_r) *(Pi_EMU/Pi_bar)^(gamma_pi*(1-gamma_r)) *(Y_emu/lag_Y_emu)^(gamma_y*(1-gamma_r)) *lag_R^gamma_r*E_M;
    n*b =  n*lag_R_ib*b(-1)/Pic +(1-n)*(1/(tauC +(1-tauC)*Terms^(1-iota_C)))^(1/(1-iota_C))*C_H_s -n*(1/(tauC*Terms^(-(1-iota_C)) +(1-tauC)))^(1/(1-iota_C)) *C_F + n*(LF_F -  lag_RLF_H_s*lag_LF_F/Pic ) - (1-n)*(LF_H_s -  lag_RLF_F*lag_LF_H_s/Pic );
   
    //Shocks
    premium = rho_premium*premium(-1) + e_premium;
    prefd = rho_prefd*prefd(-1) + e_prefd +e_prefd_com;
    prefd_s = rho_prefd*prefd_s(-1) + e_prefd_s +e_prefd_com;
    prefc = rho_prefc*prefc(-1) + e_prefc;
    prefc_s = rho_prefc*prefc_s(-1) + e_prefc_s;
    zc = rho_zc*zc(-1) + e_zc +e_zc_com;
    zd = rho_zd*zd(-1) + e_zd;
    zc_s = rho_zc*zc_s(-1) + e_zc_s +e_zc_com;
    zd_s = rho_zd*zd_s(-1) + e_zd_s;
    log(A) = rhoA*log(A(-1)) + epsA;
    log(Gov) = (1-rhoG)*log(g*Yc) + rhoG*log(Gov(-1)) + epsG;
    log(Gov_s) = (1-rhoG)*log(g_s*Yc_s) + rhoG*log(Gov_s(-1)) + epsG;
    log(gammaB) = (1-rhogammaB)*log(gammaB_bar) + rhogammaB*log(gammaB(-1)) + epsgammaB;
    log(TPS) = rhoTPS*log(TPS(-1)) + epsTPS;
    riskp = (1-rho_risk)*log(sigma_bar) + rho_risk*riskp(-1) + e_risk;
    riskp_s = (1-rho_risk)*log(sigma_bar) + rho_risk*riskp_s(-1) + e_risk_s;
    riskFp = (1-rho_riskF)*log(sigmaF_bar) + rho_riskF*riskFp(-1) + e_riskF;
    riskFp_s = (1-rho_riskF)*log(sigmaF_bar) + rho_riskF*riskFp_s(-1) + e_riskF_s;
    riska = riskp(+1);
    riska_s = riskp_s(+1);
    riskFa = riskFp(+1);
    riskFa_s = riskFp_s(+1);

end;

steady; 
check; 

shocks;
var e_m;stderr 0.001;
var e_risk;stderr 0.05;
var e_riskF;stderr 0.05;
var e_premium;stderr 0.0010;
var epsA;stderr 0.01;
var epsG;stderr 0.01;
var epsgammaB;stderr 0.001;
var epsTPS;stderr 0.001;
end;

stoch_simul(order=1,irf=40,nograph,pruning)  r;